VERSION 0.8 # https://docs.earthly.dev/docs/earthfile#version
FROM python:3

ARG --global build_dir="public"


################
# Main targets #
################

{% include "./fragments/node.earth" %}

# Build the site
# https://www.gatsbyjs.com/docs/how-to/previews-deploys-hosting/deploying-to-gitlab-pages
build:
    ARG yama_env="production"

    FROM +node-base
    WORKDIR /workdir
    CACHE .cache

    COPY . .

    # Uncomment if you wish to disable telemetry. Learn more at https://www.gatsbyjs.com/docs/telemetry/
    #ENV GATSBY_TELEMETRY_DISABLED=1
    ENV YAMA_ENV=$yama_env

    RUN ./node_modules/.bin/gatsby build --verbose

    SAVE ARTIFACT $build_dir build_result AS LOCAL $build_dir





##################
# Helper targets #
##################

{% include "./fragments/node-helpers.earth" %}

# Run `gatsby develop` dev server with $PWD mounted. Run locally with `earthly +dev`.
# Note that if you exit Earthly (eg. via Ctrl+c), Earthly will immediately exit and leave the container running.
# You can manually stop it with `earthly +stop-dev` (or `docker stop earthly-dev-server`).
dev:
    ARG port=8000
    ARG container_name="earthly-dev-server"

    LOCALLY
        WITH DOCKER --load earthly-dev-server-image=+node-base
            # We use `./node_modules/.bin/gatsby` instead of `npm run develop` so that we can pass flags.
            # We pass --host=0.0.0.0 because otherwise gatsby will try to bind to "localhost", which doesn't route to
            # 0.0.0.0 in the container's /etc/hosts. We could add a `--add-host` parameter to `docker run` instead.
            RUN docker run --rm \
                           --volume="$PWD:/workdir:Z" \
                           --publish [::1]:$port:8000 \
                           --name="$container_name" \
                           earthly-dev-server-image \
                           ./node_modules/.bin/gatsby develop --host=0.0.0.0 --port=8000
	END

stop-dev:
    ARG container_name="earthly-dev-server"

    LOCALLY
        RUN docker stop "$container_name"

################
# Swift upload #
################

{% include "./fragments/swift.earth" %}
